#include "disp.h"
#include <avr/io.h>

//kijelz bekapcsols, inicializci
void disp_init()
{
	PORTB &= ~(DSP_EN | DSP_MOSI | DSP_SCLK);
	PORTD &= ~(DSP_RCK);
	PORTB |= (DSP_CLR);

	DDRB |= (DSP_CLR | DSP_EN | DSP_MOSI | DSP_SCLK);
	DDRD |= DSP_RCK;

	//SPI bekapcsolsa, master mode, 2-es eloszts
	SPCR |= (1<<SPE) | (1<<MSTR)|(1<<DORD);
	//SPSR = 1;		//SPI2X bekapcsols

	PORTB |= (DSP_CLR);
	PORTB &= ~(DSP_EN);
	PORTD &= ~(DSP_RCK);

	//init fast PWM on TC0
	TCCR0A = (1<<COM0A1) | (1<<COM0A0) | (1<<WGM00) | (1<<WGM01);
	TCCR0B = (1<<CS00) | (1<<CS02); //1024 prescaler
	OCR0A = 255;
}

void disp_send(uint8_t * buf)
{
	for (uint8_t i = 0; i<6; i++)
	{
		SPDR = buf[i];
		while(!(SPSR&(1<<SPIF)));
	}

	//set clear off, en off, send rck
	PORTD |= DSP_RCK;
	PORTD &= ~(DSP_RCK);
}
