#ifndef ESP_H
#define ESP_H

#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>




extern volatile uint8_t esp_buffer[ESP_BUFSIZE];
extern volatile uint8_t esp_bufptr;
extern volatile uint8_t esp_timeout;
extern volatile uint8_t esp_stat;
extern volatile uint8_t esp_power;		//wifi ki-be kapcsols

extern volatile uint8_t esp_llen;		//esp line length until \r

//alapbelltsok, tvitel belltsa
void esp_init();

//szveges parancs kldse
void esp_send(const uint8_t *dta);

//tviteli sebessg belltsa
//gyorsabb s kevesebb hiba
void esp_set_baud();

//modul bekapcsolsa
void esp_on();

//esp modul kikapcsolsa
//energia megtakarts vagy ne nem kell
void esp_off();

//esp modul konfigurlsa
//a belltott rtkek szerint
void esp_conf();

void esp_read_ack();

//vrunk a megfelel llapotra (type)
//tout - *250ms idkorlt
uint8_t esp_ack_wait(uint8_t type, uint8_t tout);

 #endif