#include "sys.h"
#include "cmd.h"

//for wifi communication
//and command interpreter
uint8_t command;
uint8_t value;
uint8_t esp_mode = ESP_CON_OFF;
uint8_t ledbrg;

#define BOOT_LOGO_TIME	70 //*10ms = 1sec

void alarm_check()
{
	for (uint8_t i = 0; i<4; i++)
	{
		if ((al_stat&(1<<i)) && 
		(h == al_hour[i]) && 
		(m == al_min[i])) 
		alarm_start();
	}
}

//a mode vltoz szerint belltja kijelz tartalmt
//a refresh flag-et lltja
void disp_set_mode()
{
	uint8_t mm = (mode&0xf0)>>4;	//a fels 4 bit a f md
	uint8_t sm = mode&0x0f;

	//ra kijelse md
	switch(mm)
	{
	//clock
		case 0:
		{
			disp_buf[0] = pgm_read_byte(character+ h/10);
			disp_buf[1] = pgm_read_byte(character+ h%10) | ((!sm || (sm==1&&blink))?DSP_DP:0);
			disp_buf[2] = pgm_read_byte(character+ m/10);
			disp_buf[3] = pgm_read_byte(character+ m%10) | ((!sm || (sm==2&&blink))?DSP_DP:0);
			disp_buf[4] = pgm_read_byte(character+ s/10);
			disp_buf[5] = pgm_read_byte(character+ s%10) | (((!sm || sm==3)&&blink)?DSP_DP:0);
			break;
		}

	//countdown
		case 1:
		{
			disp_buf[0] = pgm_read_byte(character+ cd_h/10);
			disp_buf[1] = pgm_read_byte(character+ cd_h%10) | ((!sm || (sm==1&&blink))?DSP_DP:0);
			disp_buf[2] = pgm_read_byte(character+ cd_m/10);
			disp_buf[3] = pgm_read_byte(character+ cd_m%10) | ((!sm || (sm==2&&blink))?DSP_DP:0);
			disp_buf[4] = pgm_read_byte(character+ cd_s/10);
			disp_buf[5] = pgm_read_byte(character+ cd_s%10) | ( (!(sm||cd_en) || ((sm==3||cd_en)&&blink))?DSP_DP:0);
			//ms!=3 || blink 
			break;
		}

	//set alarm
		case 2:
		case 3:
		case 4:
		case 5:
		{
			mm-=2;
			disp_buf[0] = pgm_read_byte(character+ 10);	//a
			disp_buf[1] = pgm_read_byte(character+ mm+1);

			if(sm<3)
			{
				disp_buf[2] = pgm_read_byte(character+ al_hour[mm]/10);
				disp_buf[3] = pgm_read_byte(character+ al_hour[mm]%10) | ((!sm || (sm==1&&blink))?DSP_DP:0);
				disp_buf[4] = pgm_read_byte(character+ al_min[mm]/10);
				disp_buf[5] = pgm_read_byte(character+ al_min[mm]%10) | ((!sm || (sm==2&&blink))?DSP_DP:0);
			}
			else
			{
				disp_buf[2] = 0;
				disp_buf[3] = 0;
				disp_buf[4] = pgm_read_byte(character+ 16);	//o
				disp_buf[5] = pgm_read_byte(character+ ((al_stat&(1<<mm))?18:15)) | (blink?DSP_DP:0);
			}
			break;
		}

	//wifi configuration settings
		case 6:
		{
			disp_buf[0] = pgm_read_byte(character+ 14);	//e
			disp_buf[1] = pgm_read_byte(character+ 5);	//s
			disp_buf[2] = pgm_read_byte(character+ 19);	//p
			if (sm<=2)
			{
				disp_buf[3] = 0;
				disp_buf[4] = pgm_read_byte(character+ esp_mode);
				disp_buf[5] = pgm_read_byte(character+ ((esp_stat&0x80)?18:15)) | (((sm==1)&&blink)?DSP_DP:0);
			}
			else
			{
				disp_buf[3] = 0;
				disp_buf[4] = pgm_read_byte(character+ (esp_stat>>4));
				disp_buf[5] = pgm_read_byte(character+ (esp_stat&15)) | ((blink)?DSP_DP:0);
			}
			
			break;
		}
	
	//other settings
		case 7: switch(sm)
		{
			//other
			case 0:
			{
				disp_buf[0] = pgm_read_byte(character+ 16); //o
				disp_buf[1] = pgm_read_byte(character+ 17); //t
				disp_buf[2] = pgm_read_byte(character+ 20); //h
				disp_buf[3] = pgm_read_byte(character+ 0x0e); //e
				disp_buf[4] = pgm_read_byte(character+ 21); //r
				disp_buf[5] = blink?DSP_DP:0;
			} break;

			case 1:
			{
				disp_buf[0] = pgm_read_byte(character+ 22); //L
				disp_buf[1] = pgm_read_byte(character+ 0x0e); //e
				disp_buf[2] = pgm_read_byte(character+ 0x0d); //d
				disp_buf[3] = 0;
				disp_buf[4] = pgm_read_byte(character+ ((ledbrg&0xf0)>>4));
				disp_buf[5] = pgm_read_byte(character+ (ledbrg&0x0f)) | (blink?DSP_DP:0);
			} break;

			case 2:
			{
				disp_buf[0] = pgm_read_byte(character+ 0x0a); //A
				disp_buf[1] = pgm_read_byte(character+ 22); //L
				disp_buf[2] = pgm_read_byte(character+ 17); //t
				disp_buf[3] = 0;
				disp_buf[4] = pgm_read_byte(character+ (al_def_time/10));
				disp_buf[5] = pgm_read_byte(character+ (al_def_time%10)) | (blink?DSP_DP:0);
			} break;

			case 3:
			{
				disp_buf[0] = pgm_read_byte(character+ 0x0d); //d
				disp_buf[1] = pgm_read_byte(character+ 16); //o
				disp_buf[2] = pgm_read_byte(character+ 17); //t
				disp_buf[3] = 0;
				disp_buf[4] = pgm_read_byte(character+ (blink_max/10));
				disp_buf[5] = pgm_read_byte(character+ (blink_max%10)) | (blink?DSP_DP:0);
			} break;
		}
	}
}

//vlts a mdok kztt
void btn1gest()
{
	if (mode&3) mode = (mode+1)&0xf3;
	else mode = (mode+16)&0x7f;

	if((mode&0xf0)>0x70) mode=0;

	//jelenleg csak 7 md van
	//ra, visszasz, alarm1-4, esp, debug
}

//belps a belltsokba
void btn2gest()
{
	if(mode&3) mode &= 0xf0;
	else mode++;
}

//rtkek lltsa
void rotCWgest()
{
	uint8_t mm = (mode&0xf0)>>4;	//a fels 4 bit a f md
	uint8_t sm = mode&0x0f;

	if (mm == 0) switch(sm)
	{
		case 1: if(h==0) h = 23; else h--; break;
		case 2: if(m==0) m = 59; else m--; break;
		case 3: if(s==0) s = 59; else s--; break;
	}

	else if (mm == 1) switch(sm)
	{
		case 0: cd_en = 0; break;
		case 1: if(cd_h==0) cd_h = 23; else cd_h--; break;
		case 2: if(cd_m==0) cd_m = 59; else cd_m--; break;
		case 3: if(cd_s==0) cd_s = 59; else cd_s--; break;
	}

	else if (mm<6)
	{
		mm-= 2;
		switch(sm)
		{
		case 1: if (al_hour[mm]==0) al_hour[mm] = 23; else al_hour[mm]--; break;
		case 2: if (al_min[mm]==0) al_min[mm] = 59; else al_min[mm]--; break;
		case 3: al_stat ^= (1<<mm);
		}
	}

	else if (mm==6)
	{
		switch(sm)
		{
			case 1: if (!esp_mode)esp_mode=2; else esp_mode--; esp_conf(esp_mode); break;
		}
	}

	else if (mm==7)	switch(sm)
	{
		case 1:
		{
			ledbrg--;
			disp_set_brg(ledbrg);
			break;
		};
		case 2:
		{
			if(al_def_time) al_def_time--;
			else al_def_time=59;
			break;
		};
		case 3:
		{
			if(blink_max>11) blink_max--;
			else blink_max=99;
			break;
		};
	};
}

void rotCCWgest()
{
	uint8_t mm = (mode&0xf0)>>4;	//a fels 4 bit a f md
	uint8_t sm = mode&0x0f;

	if (mm == 0) switch(sm)
	{
		case 1: if(h==23) h = 0; else h++; break;
		case 2: if(m==59) m = 0; else m++; break;
		case 3: if(s==59) s = 0; else s++; break;
	}

	else if (mm == 1) switch(sm)
	{
		case 0: cd_en = 1; break;
		case 1: if(cd_h==23) cd_h = 0; else cd_h++; break;
		case 2: if(cd_m==59) cd_m = 0; else cd_m++; break;
		case 3: if(cd_s==59) cd_s = 0; else cd_s++; break;
	}

	else if (mm<6)
	{
		mm-= 2;
		switch(sm)
		{
			case 1: if (al_hour[mm]==24) al_hour[mm] = 0; else al_hour[mm]++; break;
			case 2: if (al_min[mm]==59) al_min[mm] = 0; else al_min[mm]++; break;
			case 3: al_stat ^= (1<<mm);
		}
	}

	else if (mm==6)
	{
		switch(sm)
		{
			case 1: if (esp_mode==2)esp_mode=0; else esp_mode++; esp_conf(esp_mode); break;
		}
	}

	else if (mm==7)	switch(sm)
	{
		case 1:
		{
			ledbrg++;
			disp_set_brg(ledbrg);
			break;
		};
		case 2:
		{
			if(al_def_time==59) al_def_time=0;
			else al_def_time++;
			break;
		};
		case 3:
		{
			if(blink_max==99) blink_max=10;
			else blink_max++;
			break;
		};
	};
}

void processCommand()
{
	uint8_t cmd;
	uint8_t val;
	uint8_t k = 0;

	uint8_t ptr = 0;
	while(ptr<esp_llen) if (esp_buffer[ptr++]==':')break;
	if (!ptr || esp_buffer[ptr-1]!=':') return;

	cmd = esp_buffer[ptr++];
	val = esp_buffer[ptr++];

	command = cmd;
	value = val;

	switch(cmd)
	{
		case CMD_S_H: h = val; break;
		case CMD_S_M: m = val; break;
		case CMD_S_S: s = val; break;
		case CMD_S_AH: al_hour[val] = esp_buffer[ptr]; break;
		case CMD_S_AM: al_min[val] = esp_buffer[ptr]; break;
		case CMD_S_AS: al_stat = val; break;
		case CMD_S_CDH: cd_h = val; break;
		case CMD_S_CDM: cd_m = val; break;
		case CMD_S_CDS: cd_s = val; break;
		case CMD_S_CDE: cd_en = val; break;
		case CMD_S_SSID: ptr--; while(esp_buffer[ptr] != '\r') {eeprom_busy_wait(); eeprom_write_byte(str_ssid+k, esp_buffer[ptr++]); k++; ptr++;}; eeprom_write_byte(str_ssid+k,0); break;
		case CMD_S_PWD:	ptr--; while(esp_buffer[ptr] != '\r') {eeprom_busy_wait(); eeprom_write_byte(str_wifipass+k, esp_buffer[ptr++]); k++; ptr++;}; eeprom_write_byte(str_ssid+k,0); break;
		case CMD_S_MODE: mode = val; break;
		case CMD_S_BRG: disp_set_brg(val); break;
		case CMD_S_AL: al_timeout = val; set_stat(ST_ALARM); break;
	}

}

int main(void)
{
	//init systems needed for bootloader check
	init_vars();
	clock_on();
	disp_on();
	disp_show();
	btn_on();
	alarm_on();
	alarm_val(0);
	sei();

	//DO NOT DELETE THIS
	//USE NO PASSWORD SWITCH
	//tho if used, for early rejection
	//not sure if otherwise would work too
	if (bootloader_check()&&bootloader_pwd())
	{
		//start downcount to display boot logo
		dcntr = BOOT_LOGO_TIME;
		disp_buf[0] = 1;
		disp_buf[1] = pgm_read_byte(character+ 11);
		disp_buf[2] = pgm_read_byte(character+ 16);
		disp_buf[3] = pgm_read_byte(character+ 16);
		disp_buf[4] = pgm_read_byte(character+ 17);
		disp_buf[5] = 32;
		disp_show();
		while(dcntr);

		//shut down system
		btn_off();
		disp_off();
		clock_off();
		cli();

		asm("jmp 0x3000;");
	}

	//continue init system not needed for bootloader check
	uart_on();

	//load init values
	ledbrg = disp_get_brg();

	//adatfeldolgoz llapotgp
	while(1)
	{
		if (is_stat(ST_REFRESH)) {disp_set_mode(); disp_show(); clear_stat(ST_REFRESH);}

		if (is_stat(ST_ALCHG)) {alarm_check(); clear_stat(ST_ALCHG);}
		
		if (is_stat(ST_ALARM)) {alarm_val(blink);}
		else alarm_val(0);

		if (is_stat(ST_ESP_CR)) {esp_read_ack(); if ((esp_stat&0x0f) == ESP_PACK) processCommand(); clear_stat(ST_ESP_CR);}

		//input handling
		while (event_flag)
		{
			if (event_is(EVENT_BTN1)) {btn1gest(); event_clr(EVENT_BTN1);}
			if (event_is(EVENT_BTN2)) {btn2gest(); event_clr(EVENT_BTN2);}
			if (event_is(EVENT_RCW)) {rotCWgest(); event_clr(EVENT_RCW);}
			if (event_is(EVENT_RCCW)) {rotCCWgest(); event_clr(EVENT_RCCW);}
		}
	}

	return 0;
}